﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using WriteErase.ClassBase;
using WriteErase.ClassData;

namespace WriteErase.ClassPages
{
    /// <summary>
    /// Логика взаимодействия для PageAuthorization.xaml
    /// </summary>
    public partial class PageAuthorization : Page
    {
        private int countEnter = 0;
        private string captcha = "";
        private DispatcherTimer timer = new DispatcherTimer();
        public PageAuthorization()
        {
            InitializeComponent();
            
            timer.Interval = new TimeSpan(0, 0, 10);
            timer.Tick += StopTimer;
        }

        private void StopTimer(object sender, EventArgs e)
        {
            changeEnabled(true);
            timer.Stop();
        }

        private void btnEnterClick(object sender, RoutedEventArgs e)
        {
            User user = BaseConnection.kotBase.User.FirstOrDefault(tb => tb.UserLogin == tbxLogin.Text && tb.UserPassword == pbxPassword.Password);
            if(user != null && gbCaptcha.Visibility == Visibility.Collapsed)
            {
                UserSession.user = user;
                MainFrame.mainFrame.Navigate(new PageMain());
                MessageBox.Show("Авторизация прошла успешно");
            }
            else if(gbCaptcha.Visibility == Visibility.Visible && tbxCaptcha.Text == captcha && user != null)
            {
                UserSession.user = user;
                MainFrame.mainFrame.Navigate(new PageMain());
                MessageBox.Show("Авторизация прошла успешно");
            }
            else
            {
                MessageBox.Show("Не удалось авторизироваться");
                gbCaptcha.Visibility = Visibility.Visible;
                countEnter++; 
                btnGenerateCaptchaClick(null, null);
                pbxPassword.Password = "";
                tbxCaptcha.Text = "";
                if (countEnter > 1)
                {
                    timer.Start();
                    changeEnabled(false);
                }                    
            }       
        }

        private void btnGuestClick(object sender, RoutedEventArgs e)
        {
            MainFrame.mainFrame.Navigate(new PageMain());
        }

        private void btnGenerateCaptchaClick(object sender, RoutedEventArgs e)
        {
            string Line = "";

            Random rnd = new Random();            
            SolidColorBrush colorFon = new SolidColorBrush(Color.FromRgb(255, 255, 255));
            SolidColorBrush colorSymbol = new SolidColorBrush(Color.FromRgb(25, 25, 25));
            Canvas captchaCanvas = new Canvas()
            {
                Width = 150,
                Height = 40,
                Background = colorFon
            };

            int lineLenght = rnd.Next(4, 7);
            int startPoint = 10;
            for (int i = 0; i < lineLenght; i++)
            {
                string symbol = "";
                switch (rnd.Next(0, 2))
                {
                    case 0:
                        {
                            int num = rnd.Next(0, 10);
                            symbol = num.ToString();
                            break;
                        }
                    case 1:
                        {
                            char c = (char)rnd.Next(65, 81);
                            symbol = c.ToString();
                            break;
                        }
                }
                Line += symbol;

                int yPoint = rnd.Next(20);
                int rndWeight = rnd.Next(0, 2);
                int rndDecoration = rnd.Next(0, 2);
                
                TextBlock tb = new TextBlock()
                {
                    Text = symbol,
                    FontSize = 20,
                    FontFamily = new FontFamily("Comic Sans MS"),
                    Foreground = colorSymbol,
                    FontWeight = (rndWeight == 0)? FontWeights.Normal : FontWeights.Bold,
                    TextDecorations = (rndDecoration == 0)? TextDecorations.Strikethrough : TextDecorations.Baseline,
                    Padding = new Thickness(startPoint, yPoint, 0, 0)
                };
                captchaCanvas.Children.Add(tb);
                startPoint += 20;
            }
            int countLine = rnd.Next(3, 7);
            for (int i = 0; i <= countLine; i++)
            {
                SolidColorBrush color;
                while (true)
                {
                    color = new SolidColorBrush(Color.FromRgb((byte)rnd.Next(0, 256), (byte)rnd.Next(0, 256), (byte)rnd.Next(0, 256)));
                    if (color != colorFon && color != colorSymbol) break;
                }
                Line line = new Line()
                {
                    X1 = rnd.Next(100),
                    Y1 = rnd.Next(30),
                    X2 = rnd.Next(140),
                    Y2 = rnd.Next(30),
                    Stroke = color,
                    StrokeThickness = 1.5
                };
                captchaCanvas.Children.Add(line);
            }

            captcha = Line;
            cCaptcha.Content = captchaCanvas;
        }

        private void changeEnabled(bool value)
        {
            tbxLogin.IsEnabled = value;
            pbxPassword.IsEnabled = value;
            tbxCaptcha.IsEnabled = value;
            btnEnter.IsEnabled = value;
            btnGenerateCaptcha.IsEnabled = value;            
            gbCaptcha.Visibility = (value)?Visibility.Visible:Visibility.Collapsed;
            if(value)btnGenerateCaptchaClick(null, null);
        }
    }
    
}
